#!/usr/local/bin/perl

################################################################################
package Account;
################################################################################

################################################################################
package Allocation;
################################################################################

################################################################################
package ChargeRate;
################################################################################

sub add {
my $pkg = shift;
my(%ARGS); foreach (@_) {($key,$value)=split(/=/,$_);$ARGS{$key}=$value;}

# Authorize
unless (&authorize('bank',@_))
   { return &deny("$me is not authorized to run $ARGS{COMMAND}"); }

# Usage
if ($ARGS{USAGE}||(!$ARGS{MACHINE}||!$ARGS{TYPE}||!$ARGS{NAME}||!$ARGS{RATE}))
   { return &usage("$ARGS{COMMAND} MACHINE=<machine> TYPE=<chargetype> NAME=<chargename> RATE=<chargerate>"); }

# Exists
&db("select machinename from chargerate where machinename='$ARGS{MACHINE}' and chargetype='$ARGS{TYPE}' and chargename='$ARGS{NAME}'") || return &fail($dberror)
;
if ($ROWS)
   {return &deny("Chargerate MACHINE=$ARGS{MACHINE} TYPE=$ARGS{TYPE} NAME=$ARGS{NAME} already exists.");}

# Insert
&db("insert into chargerate (machinename,chargetype,chargename,chargerate) values ('$ARGS{MACHINE}','$ARGS{TYPE}','$ARGS{NAME}',$ARGS{RATE})") || return &fail($dberror);

# Log
# Log to txnlog
&db("insert into txnlog (txntype,machine,timestamp,authorization) values ('add_c
hargerate','$ARGS{MACHINE}','now','$me')") || return &fail($dberror);

# Return
&bank_log(4,"@_");
return "Successfully created chargerate MACHINE=$ARGS{MACHINE} TYPE=$ARGS{TYPE} NAME=$ARGS{NAME} RATE=$ARGS{RATE}";
#return &success("Successfully created chargerate MACHINE=$ARGS{MACHINE} TYPE=$ARGS{TYPE} NAME=$ARGS{NAME} RATE=$ARGS{RATE}");

}

################################################################################
package StoreItemExample;
################################################################################

sub new {
	my ($pkg, $name, $price, $rebate) = @_;
	bless {
	# Attributes are marked with a leading underscore, to signify that they
	# are private (just a convention)
	_name => $name, _price => $price, _rebate => $rebate
	}, $pkg;
	return $pkg;
	}

# Accessor methods
sub sales_tax {shift; @_ ? $_sales_tax = shift : $_sales_tax}
sub name {my $obj = shift; @_ ? $obj->{_name} = shift : $obj->{_name}}
sub rebate {my $obj = shift; @_ ? $obj->{_rebate} = shift : $obj->{_rebate}}
sub price {my $obj = shift; @_ ? $obj->{_price} = shift : $obj->{_price} - $obj->{_rebate}}

sub net_price {
	my $obj = shift;
	return $obj->price * (1 + $obj->sales_tax / 100);
	}

################################################################################
package CheckPoint;
################################################################################

################################################################################
package Reservation;
################################################################################

################################################################################
package SubAccount;
################################################################################

################################################################################
package TxnLog;
################################################################################

################################################################################
package User;
################################################################################

1;
