################################################################################
# 
#	qbank.ph
#
#	A header file for QBank
#
################################################################################

$VERSION = "2.10.4";           # QBank version

@BANK_ADMINS = ("root","loadl");  # List of users with bank level privileges

$MACHINE = "DEFAULT";             # Name of this system or cluster

$BANK_HOST = "localhost";        # qbankd server host
$BANK_PORT = "7111";              # qbankd server port

$DB_TYPE = "Pg";                  # database type (Pg, etc.)
$DB_NAME = "qbank";   						# database name
$DB_HOST = "localhost";          # database server host
$DB_PORT = "default";             # database server port

$LOG_DIR = "/var/log/qbank";           # Directory to which log files are written
$DBG_LOG = "dbglog";               # bank client debug log
$BNK_LOG = "bnklog";               # bank server connection log
$LOG_SIZE = 1000000;               # maximum log size before rolling

$DEBUG=1;                         # DEBUG is ON if 1, OFF if (0|unset)

